package de.hdm_stuttgart.mi.sda2.jpa.university;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.xml.bind.JAXBException;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hdm_stuttgart.mi.sda2.jpa.cd.domain.Lecture;
import de.hdm_stuttgart.mi.sda2.jpa.cd.domain.Student;
import de.hdm_stuttgart.mi.sda2.jpa.cd.domain.StudentLecture;

/**
 * A simple http://logging.apache.org/log4j/2.x demo, see file log4j2.xml for
 * configuration options.
 * 
 */
public class Driver {
   private static Logger log = LogManager.getLogger(Driver.class);

   /**
    * @param args
    *           Unused
    * @throws JAXBException
    */
   public static void main(String[] args) throws JAXBException {

      final EntityManagerFactory factory = Persistence
            .createEntityManagerFactory("persistenceUnit");
      final EntityManager manager = factory.createEntityManager();

      final EntityTransaction tx = manager.getTransaction();

      final Student joe = new Student("Joe Blix", 12346);
      final Lecture db = new Lecture("Database systems", 11312);
      final StudentLecture joeDb = new StudentLecture(joe, db, 5);

      tx.begin();
      {
         // manager.persist(joe); // not required if cascading persist is
         // enabled
         // manager.persist(db);
         manager.persist(joeDb);
      }
      tx.commit();

      tx.begin();
      {
         manager.refresh(joe);
         System.out.println("Lectures of Joe:");
         for (StudentLecture sl : joe.getLectures()) {
            System.out.println(sl.getLecture().getTitle());
         }
      }
      tx.commit();

      tx.begin();
      {
         System.out.println("Deleting Joe from Database");
         manager.remove(joe);
      }
      tx.commit();

   }

}
